unit im_RotateFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, Buttons,
  GR32, GR32_Image,GR32_Transforms,im_basic,math;

type
  TRotateCTRLForm = class(TForm)
    GroupBox1: TGroupBox;
    FlipHorizontalBtn: TSpeedButton;
    FlipVerticalBtn: TSpeedButton;
    Edit1: TEdit;
    UpDown1: TUpDown;
    CheckBox1: TCheckBox;
    RotateRG: TRadioGroup;
    Imagepreview1: TImgView32;
    Button1: TButton;
    Button2: TButton;
    Splitter1: TSplitter;
    HelpBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure RotateRGClick(Sender: TObject);
    procedure FlipVerticalBtnMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FlipHorizontalBtnMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    FSrcBitmap:TBitmap32;
    FDestBitmap:TBitmap32;
  end;

var
  RotateCTRLForm: TRotateCTRLForm;

implementation
uses im_D5;
{$R *.DFM}

procedure TRotateCTRLForm.FormCreate(Sender: TObject);
begin
  left := RotateCTRLFormX;
  top := RotateCTRLFormY;
  FDestBitmap:=TBitmap32.Create;
  FSrcBitmap:=TBitmap32.Create;
end;

procedure TRotateCTRLForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  RotateCTRLFormX := RotateCTRLForm.left;
  RotateCTRLFormY:= RotateCTRLForm.top;
  FDestBitmap.Free;
  FSrcBitmap.Free;
end;

procedure TRotateCTRLForm.FormShow(Sender: TObject);
begin
  checkbox1.Checked:=false;
  imagepreview1.bitmap.Assign(FsrcBitmap);
end;

procedure TRotateCTRLForm.Edit1Change(Sender: TObject);
var i:Integer;
begin
imagepreview1.Bitmap.Assign(FSrcBitmap);
i:=ensurerangeiiii(strtointdef(edit1.text,0),-360,360);
im_Basic.ImageRotate(imagepreview1.bitmap,i);
end;

procedure TRotateCTRLForm.FlipHorizontalBtnMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  imagefliphoriz(imagepreview1.bitmap);
end;

procedure TRotateCTRLForm.FlipVerticalBtnMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  imageflipvert(imagepreview1.bitmap);
end;

procedure TRotateCTRLForm.RotateRGClick(Sender: TObject);
begin
case RotateRG.ItemIndex of
 0:Edit1.Text:='0';
 1:Edit1.Text:='90';
 2:Edit1.Text:='180';
 3:Edit1.Text:='270';
 end;
edit1change(self);
end;





procedure TRotateCTRLForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(1000);
end;

end.
